require 'thor'
require 'sinatra/generate/version'
require 'date'
require 'active_support/inflector'
require 'yaml'

module Sinatra
  module Generate
    class CLI < Thor
      include Thor::Actions

      option :path, desc: 'Where to place the migration file', aliases: '-p'
      desc 'migration', 'generate a blank database migration file'
      def migration name
        dotfile = '.sinatragen'

        defaults = File.file?(dotfile) ? ::YAML.load_file(dotfile) : {}
        defaults = {
          path: 'lib/migrations'
        }.merge defaults

        self.options = Thor::CoreExt::HashWithIndifferentAccess.new defaults.merge(options)

        create_file "#{options[:path]}/#{DateTime.now.strftime '%Y%m%d%H%M%S%9N'}_#{name.underscore}.rb"
      end
    end
  end
end
